"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = generateRandomBytes;

var _reactNative = require("react-native");

var _cryptoJs = _interopRequireDefault(require("crypto-js"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// @ts-ignore
function generateRandomBytes() {
  var _globalObject$ExpoMod, _globalObject$ExpoMod2;

  const globalObject = global;

  if (globalObject !== null && globalObject !== void 0 && (_globalObject$ExpoMod = globalObject.ExpoModules) !== null && _globalObject$ExpoMod !== void 0 && _globalObject$ExpoMod.ExpoRandom) {
    const bytes = globalObject.ExpoModules.ExpoRandom.getRandomBase64String(_utils.BYTE_LENGTH);
    return bytes;
  }

  if (globalObject !== null && globalObject !== void 0 && (_globalObject$ExpoMod2 = globalObject.ExpoModules) !== null && _globalObject$ExpoMod2 !== void 0 && _globalObject$ExpoMod2.ExpoCrypto) {
    const bytes = globalObject.ExpoModules.ExpoCrypto.getRandomBase64String(_utils.BYTE_LENGTH);
    return bytes;
  }

  if (_reactNative.NativeModules.ExpoRandom) {
    const bytes = _reactNative.NativeModules.ExpoRandom.getRandomBase64String(_utils.BYTE_LENGTH);

    return bytes;
  }

  if (_reactNative.NativeModules.ExpoCrypto) {
    const bytes = _reactNative.NativeModules.ExpoCrypto.getRandomBase64String(_utils.BYTE_LENGTH);

    return bytes;
  }

  if (globalObject !== null && globalObject !== void 0 && globalObject.RNPkceChallenge) {
    const bytes = globalObject.RNPkceChallenge.randomBytes(_utils.BYTE_LENGTH);
    return bytes;
  }

  const buffer = _cryptoJs.default.lib.WordArray.random(_utils.BYTE_LENGTH);

  const bytes = buffer.toString(_cryptoJs.default.enc.Base64);
  return bytes;
}
//# sourceMappingURL=generate-random-bytes.native.js.map