// @ts-ignore
import { NativeModules } from 'react-native';
import CryptoJS from 'crypto-js';
import { BYTE_LENGTH } from './utils';
export default function generateRandomBytes() {
  var _globalObject$ExpoMod, _globalObject$ExpoMod2;

  const globalObject = global;

  if (globalObject !== null && globalObject !== void 0 && (_globalObject$ExpoMod = globalObject.ExpoModules) !== null && _globalObject$ExpoMod !== void 0 && _globalObject$ExpoMod.ExpoRandom) {
    const bytes = globalObject.ExpoModules.ExpoRandom.getRandomBase64String(BYTE_LENGTH);
    return bytes;
  }

  if (globalObject !== null && globalObject !== void 0 && (_globalObject$ExpoMod2 = globalObject.ExpoModules) !== null && _globalObject$ExpoMod2 !== void 0 && _globalObject$ExpoMod2.ExpoCrypto) {
    const bytes = globalObject.ExpoModules.ExpoCrypto.getRandomBase64String(BYTE_LENGTH);
    return bytes;
  }

  if (NativeModules.ExpoRandom) {
    const bytes = NativeModules.ExpoRandom.getRandomBase64String(BYTE_LENGTH);
    return bytes;
  }

  if (NativeModules.ExpoCrypto) {
    const bytes = NativeModules.ExpoCrypto.getRandomBase64String(BYTE_LENGTH);
    return bytes;
  }

  if (globalObject !== null && globalObject !== void 0 && globalObject.RNPkceChallenge) {
    const bytes = globalObject.RNPkceChallenge.randomBytes(BYTE_LENGTH);
    return bytes;
  }

  const buffer = CryptoJS.lib.WordArray.random(BYTE_LENGTH);
  const bytes = buffer.toString(CryptoJS.enc.Base64);
  return bytes;
}
//# sourceMappingURL=generate-random-bytes.native.js.map